/**
 * Created by robin on 11/2/15.
 */


angular.module('luticate')
    .directive('dialogOkCancel', [
        function () {
            return {
                restrict: 'EA',
                transclude: true,
                templateUrl: 'views/directives/dialogokcancel.html',
                link: function link($scope, element, attrs) {
                    $scope.title = attrs.title;
                    $scope.model = {};
                    $scope.pending = false;
                    $scope.submitted = false;
                    $scope.errorString = "";

                    $scope.__submit = function()
                    {
                        $scope.submitted = true;
                        $scope.errorString = "";
                        if ($scope.form.$valid) {
                            $scope.pending = true;
                            $scope.promise = $scope.submitForm();
                            if ($scope.promise)
                            {
                                $scope.promise.then(function(data) {
                                    if ($scope.onDone) {
                                        $scope.onDone(data);
                                    }
                                    $scope.$close(data);
                                    $scope.pending = false;
                                })
                                    .catch(function(error)
                                    {
                                        if ($scope.onError) {
                                            $scope.onError(error);
                                        }
                                        if (error.Data) {
                                            $scope.errorString = error.Data;
                                        }
                                        else {
                                            $scope.errorString = error;
                                        }
                                        $scope.pending = false;
                                    });
                            }
                            else {
                                $scope.$close();
                                $scope.pending = false;
                            }
                        }
                    };

                    $scope.__cancel = function()
                    {
                        if ($scope.onCanceled) {
                            $scope.onCanceled();
                        }
                        $scope.$dismiss();
                        $scope.pending = false;
                    };
                }
            };
        }]);